//Standard Matching with maxflow
#include <stdio.h>
#include <stdlib.h>
#include <queue>

using namespace std;
#define MAXN 512

//maxflow
int n, c[MAXN][MAXN], p[MAXN], f[MAXN][MAXN];
bool used[MAXN];
bool bfs(int s, int t){
  int curr, i;
  queue<int> q;
  q.push(s);
  p[s] = -1;
  for(i = 0; i < n; i++)
    used[i] = false;
  used[s] = true;
  while(!q.empty()){
       curr = q.front(); q.pop();
       if(curr == t) return true;
       for(i = 0; i < n; i++)
       if(!used[i] && c[curr][i] > 0){
         used[i] = true;
         p[i] = curr;
         q.push(i);            
       }             
  }
  return false;
}

int maxflow(int s, int t){
  int res = 0, min, tmp;
  for(int i = 0; i < n; i++)
  for(int j = 0; j < n; j++)
    f[i][j] = 0;
  while(bfs(s, t)){
    tmp = t;
    min = c[p[t]][t];              
    while(tmp != s){
      if(min > c[p[tmp]][tmp]) min = c[p[tmp]][tmp];
      tmp = p[tmp];
    }
    tmp = t;
    while(tmp != s){
      c[p[tmp]][tmp] -= min;
      f[p[tmp]][tmp] += min;
      c[tmp][p[tmp]] += min;     
      f[tmp][p[tmp]] -= min;
      tmp = p[tmp];     
    }
    res += min;
  }
  return res;
}

//maxflow


int main(){
    int nn, i, j, k, r = 0;
    char w[MAXN], tmp[MAXN];
    //reading data and making graph
    scanf("%d", &nn);
    n = 2*nn + 2;
    for(i = 0; i < n; i++)
    for(j = 0; j < n; j++)
      c[i][j] = 0;
    scanf("%s", w);
    //printf("%s\n", w);
    for(i = 0; i < nn; i++){
      scanf("%s", tmp);
      //printf("%s", tmp);
      for(k = 0; k < 6; k++)
        for(j = 0; j < nn; j++)
          if(tmp[k] == w[j]){
          //printf("%d %d %d\n", i ,j, k);
            c[i + 1][j + nn + 1] = 1;
            c[j + nn + 1][i + 1] = 1;          
          }
    }
    for(i = 1; i <= nn; i++)
    c[0][i] = c[i][0] = 1;
    for(i = nn + 1; i < n - 1; i++)
    c[i][n-1] = c[n-1][i] = 1;
    
    r = maxflow(0, n - 1);
    /*
    printf("R:%d\n", r);
    //DEBUG!
    
    for(i = 0; i < n; i++){
      for(j = 0; j < n; j++)
      printf("%d ", f[i][j]);
      printf("\n");      
    }
    */
    
    if(r != nn){
      printf("NO\n");
      return 0;     
    }else{
      printf("YES\n");
      for(i = nn + 1; i < n - 1; i++)
      for(j = 1; j <= nn; j++){
        if(f[i][j] == -1) if(i != n - 2) printf("%d ", j); else printf("%d\n", j);      
      }
      //printf("\n");
            
    }
    
    
    //system("pause");
    return 0;    
}
