#include <iostream>
#include <cstdio>
#include <string>
using namespace std;

const int MAXN = 105;

int N;

string S;

int graph[2 * MAXN][2 * MAXN];

int source, sink;

bool used[MAXN];

bool ready;

int path[MAXN];

int match[MAXN];

void dfs(int v, int lev)
{
 if (v == sink)
 {
  ready = false;
  for (int i = 0; i < lev - 1; i++)
  {
   graph[path[i]][path[i + 1]]--;
   graph[path[i + 1]][path[i]]++;
  }
  for (int i = 1; i <= lev - 3; i += 2)
   match[path[i]] = path[i + 1] - N;
  return; 
 }
 
 if (ready)
 {
  used[v] = true; 
  for (int i = 0; i <= 2 * N + 1; i++)
   if (graph[v][i] && !used[i])
   {
    path[lev] = i;
    if (ready)
     dfs(i, lev + 1);
   }
 } 
}

int main()
{
 cin >> N;
 cin >> S;
 
 memset(graph, 0, sizeof(graph));
 
 source = 0;
 sink = 2 * N + 1;
 
 for (int i = 1; i <= N; i++) graph[source][i] = 1;
 for (int i = 1; i <= N; i++) graph[N + i][sink] = 1;
 
 for (int i = 0; i < N; i++)
 {
  string temp; cin >> temp;
  for (int j = 0; j < S.size(); j++)
   if (temp.find(S[j]) != -1) 
    graph[j + 1][N + i + 1] = 1;
 }
 
 int flow = 0;
 
 for (;;)
 {
  memset(used, false, sizeof(used));
  ready = true; path[0] = source; 
  dfs(source, 1);  
  if (ready) break;
  flow++;
 }
 
 if (flow != N)
 {
  printf("NO\n");
  return 0;
 }
 
 printf("YES\n");
 
 for (int i = 1; i <= N; i++)
  if (i == N)
   cout << match[i] << endl;
  else
   cout << match[i] << " ";
 
 return 0;
}
